<html>
<head>
<title>OgreMemoryTracker.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMemoryTracker.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMemoryTracker_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _MemoryTracker_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _MemoryTracker_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Don&#39;t include prerequisites, can cause a circular dependency</span>
<a name="l00033"></a>00033 <span class="comment">// This file must be included within another file which already has the prerequisites in it</span>
<a name="l00034"></a>00034 <span class="comment">//#include &quot;OgrePrerequisites.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#ifndef OGRE_COMPILER</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#   pragma message &quot;MemoryTracker included somewhere OgrePrerequisites.h wasn&#39;t!&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="comment">// If we&#39;re using the GCC 3.1 C++ Std lib</span>
<a name="l00040"></a>00040 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_GNUC &amp;&amp; OGRE_COMP_VER &gt;= 310 &amp;&amp; !defined(STLPORT)</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="comment">// We need to define a hash function for void*</span>
<a name="l00042"></a>00042 <span class="comment">// For gcc 4.3 see http://gcc.gnu.org/gcc-4.3/changes.html</span>
<a name="l00043"></a>00043 <span class="preprocessor">#   if OGRE_COMP_VER &gt;= 430</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#       include &lt;tr1/unordered_map&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#   else</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#       include &lt;ext/hash_map&gt;</span>
<a name="l00047"></a>00047 <span class="keyword">namespace </span>__gnu_cxx
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049     <span class="keyword">template</span> &lt;&gt; <span class="keyword">struct </span>hash&lt; void* &gt;
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051         <span class="keywordtype">size_t</span> operator()( <span class="keywordtype">void</span>* <span class="keyword">const</span> &amp; ptr )<span class="keyword"> const</span>
<a name="l00052"></a>00052 <span class="keyword">        </span>{
<a name="l00053"></a>00053             <span class="keywordflow">return</span> (<span class="keywordtype">size_t</span>)ptr;
<a name="l00054"></a>00054         }
<a name="l00055"></a>00055     };
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="preprocessor">#   endif</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>
<a name="l00061"></a>00061 <span class="keyword">namespace </span>Ogre
<a name="l00062"></a>00062 {
<a name="l00070"></a>00070 <span class="preprocessor">#if OGRE_MEMORY_TRACKER</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00077"></a>00077     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> MemoryTracker
<a name="l00078"></a>00078     {
<a name="l00079"></a>00079     <span class="keyword">protected</span>:
<a name="l00080"></a>00080         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082         <span class="comment">// Allocation record</span>
<a name="l00083"></a>00083         <span class="keyword">struct </span>Alloc
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             <span class="keywordtype">size_t</span> bytes;
<a name="l00086"></a>00086             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pool;
<a name="l00087"></a>00087             std::string filename;
<a name="l00088"></a>00088             <span class="keywordtype">size_t</span> line;
<a name="l00089"></a>00089             std::string <span class="keyword">function</span>;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091             Alloc() :bytes(0), line(0) {}
<a name="l00092"></a>00092             Alloc(<span class="keywordtype">size_t</span> sz, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">size_t</span> ln, <span class="keyword">const</span> <span class="keywordtype">char</span>* func)
<a name="l00093"></a>00093                 :bytes(sz), pool(p), line(ln)
<a name="l00094"></a>00094             {
<a name="l00095"></a>00095                 <span class="keywordflow">if</span> (file)
<a name="l00096"></a>00096                     filename = file;
<a name="l00097"></a>00097                 <span class="keywordflow">if</span> (func)
<a name="l00098"></a>00098                     <span class="keyword">function</span> = func;
<a name="l00099"></a>00099             }
<a name="l00100"></a>00100         };
<a name="l00101"></a>00101 
<a name="l00102"></a>00102         std::string mLeakFileName;
<a name="l00103"></a>00103         <span class="keywordtype">bool</span> mDumpToStdOut;
<a name="l00104"></a>00104         <span class="keyword">typedef</span> HashMap&lt;void*, Alloc&gt; AllocationMap;
<a name="l00105"></a>00105         AllocationMap mAllocations;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107         <span class="keywordtype">size_t</span> mTotalAllocations;
<a name="l00108"></a>00108         <span class="keyword">typedef</span> std::vector&lt;size_t&gt; AllocationsByPool;
<a name="l00109"></a>00109         AllocationsByPool mAllocationsByPool;
<a name="l00110"></a>00110         <span class="keywordtype">bool</span> mRecordEnable;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112         <span class="keywordtype">void</span> reportLeaks();
<a name="l00113"></a>00113 
<a name="l00114"></a>00114         <span class="comment">// protected ctor</span>
<a name="l00115"></a>00115         MemoryTracker()
<a name="l00116"></a>00116             : mLeakFileName(<span class="stringliteral">&quot;OgreLeaks.log&quot;</span>), mDumpToStdOut(true),
<a name="l00117"></a>00117             mTotalAllocations(0), mRecordEnable(true)
<a name="l00118"></a>00118         {
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120     <span class="keyword">public</span>:
<a name="l00121"></a>00121 
<a name="l00123"></a>00123         <span class="keywordtype">void</span> setReportFileName(<span class="keyword">const</span> std::string&amp; name)
<a name="l00124"></a>00124         {
<a name="l00125"></a>00125             mLeakFileName = name;
<a name="l00126"></a>00126         }
<a name="l00128"></a>00128         <span class="keyword">const</span> std::string&amp; getReportFileName()<span class="keyword"> const</span>
<a name="l00129"></a>00129 <span class="keyword">        </span>{
<a name="l00130"></a>00130             <span class="keywordflow">return</span> mLeakFileName;
<a name="l00131"></a>00131         }
<a name="l00133"></a>00133         <span class="keywordtype">void</span> setReportToStdOut(<span class="keywordtype">bool</span> rep)
<a name="l00134"></a>00134         {
<a name="l00135"></a>00135             mDumpToStdOut = rep;
<a name="l00136"></a>00136         }
<a name="l00138"></a>00138         <span class="keywordtype">bool</span> getReportToStdOut()<span class="keyword"> const</span>
<a name="l00139"></a>00139 <span class="keyword">        </span>{
<a name="l00140"></a>00140             <span class="keywordflow">return</span> mDumpToStdOut;
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143         
<a name="l00144"></a>00144 
<a name="l00146"></a>00146         <span class="keywordtype">size_t</span> getTotalMemoryAllocated() <span class="keyword">const</span>;
<a name="l00148"></a>00148         <span class="keywordtype">size_t</span> getMemoryAllocatedForPool(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pool) <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00160"></a>00160         <span class="keywordtype">void</span> _recordAlloc(<span class="keywordtype">void</span>* ptr, <span class="keywordtype">size_t</span> sz, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pool = 0,
<a name="l00161"></a>00161                           <span class="keyword">const</span> <span class="keywordtype">char</span>* file = 0, <span class="keywordtype">size_t</span> ln = 0, <span class="keyword">const</span> <span class="keywordtype">char</span>* func = 0);
<a name="l00163"></a>00163         <span class="keywordtype">void</span> _recordDealloc(<span class="keywordtype">void</span>* ptr);
<a name="l00164"></a>00164 
<a name="l00166"></a>00166         <span class="keywordtype">void</span> setRecordEnable(<span class="keywordtype">bool</span> recordEnable)
<a name="l00167"></a>00167         {
<a name="l00168"></a>00168             mRecordEnable = recordEnable;
<a name="l00169"></a>00169         }
<a name="l00170"></a>00170 
<a name="l00172"></a>00172         <span class="keywordtype">bool</span> getRecordEnable()<span class="keyword"> const</span>
<a name="l00173"></a>00173 <span class="keyword">        </span>{
<a name="l00174"></a>00174             <span class="keywordflow">return</span> mRecordEnable;
<a name="l00175"></a>00175         }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         ~MemoryTracker()
<a name="l00178"></a>00178         {
<a name="l00179"></a>00179             reportLeaks();
<a name="l00180"></a>00180         }
<a name="l00181"></a>00181 
<a name="l00183"></a>00183         <span class="keyword">static</span> MemoryTracker&amp; <span class="keyword">get</span>();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186     };
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="preprocessor">#endif</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
